with Chop; with Global; use global;
with Monitoring; use Monitoring;
procedure Diner is
  
   -- signalling simulation end
   protected Terminated is
		procedure SetAndTest(Done : out Boolean);
   private
	 Count : Integer := 0;
   end Terminated;
   protected body Terminated is
		procedure SetAndTest(Done : out Boolean) is
		begin
			Count := Count + 1;
			Done := (Count = Global.N);
		end SetandTest;
   end Terminated;

   task type Philosopher is
	  entry Start(Name: in Id);
   end Philosopher;

   task body Philosopher is
	  Self : Id;
	  GameOver : Boolean := False; -- all strokes have been done
	  AllFinished : Boolean; -- all philo have finished 
   begin
      accept Start(Name : in Id) do Self := Name; end Start;
	  loop
		 -- each cycle is counted until maximum specified
		 AnotherStroke(GameOver); exit when GameOver;
         Thinking(Self); 
         Chop.Get_LR(Self);
         Eating(Self);
         Chop.Release(Self);
         Quitting(Self);
      end loop;
	  Leaving(Self);
	  Terminated.SetAndTest(AllFinished);
	  -- the last finishing philosopher stops the simulation
	  If AllFinished then Monitoring.TimeStop; end if;
   end Philosopher;

   Philosophers : array (Id) of Philosopher;

begin
   Monitoring.TimeStart;
   For I in Id loop Philosophers(I).Start(I); end loop;
end Diner;
