--  Package Monitoring is use for instrumenting the package Chop
--  counting the number of accepted requests when one philosopher already eats
--  counting the number of denials when one philosopher already eats
--  a hungry philosopher may meet several refusals and only one acceptance
--  deriving a ratio of concurrency denials

with Global; use Global;
package Monitoring is

	procedure AnotherStroke(Finished : out Boolean); -- controlling simulation lenght

	procedure Thinking(Philo : in Id); --  philosophers actions simulation
	procedure Eating(Philo : in Id);
	procedure Quitting(Philo : in Id);
	procedure Leaving(Philo : in Id);
	procedure Requesting_LR(Philo : in Id; Result : Integer);-- for Java notifying behaviour measurement
	procedure Requesting_R(Philo : in Id; Result : Integer);

	procedure ChopStart(Philo : in Id); --  starting service time for sticks allocation
	procedure ChopEnd(Philo : in Id); -- ending  service time for sticks allocation
	procedure InstrumentGetSuccessful(C : in Id); -- for chop package instrumentation
	procedure InstrumentGetRefusal(C : in Id);
	procedure InstrumentRelease(C : in Id);

	procedure TimeStart; -- simulation run starting date
	procedure TimeStop; -- simulation run finishing date
end Monitoring; 